/* generated using openapi-typescript-codegen -- do not edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */
import type { FileTree } from '../models/FileTree';
import type { ResourceVersionIn } from '../models/ResourceVersionIn';
import type { ResourceVersionOut } from '../models/ResourceVersionOut';
import type { ResourceVersionStatus } from '../models/ResourceVersionStatus';
import type { UserRequestAnswer } from '../models/UserRequestAnswer';
import type { UserSynchronizationRequestIn } from '../models/UserSynchronizationRequestIn';
import type { CancelablePromise } from '../core/CancelablePromise';
import { OpenAPI } from '../core/OpenAPI';
import { request as __request } from '../core/request';
export class ResourceVersionService {
    /**
     * List versions of a resource
     * List all the resource version for a specific resource.
     *
     * Permission 'resource:read' required.
     * @param rid
     * @param versionStatus Which versions of the resource to include in the response. Permission `resource:read_any` required if None or querying for non-public resources, otherwise only permission `resource:read` required.
     * @returns ResourceVersionOut Successful Response
     * @throws ApiError
     */
    public static resourceVersionListResourceVersions(
        rid: string,
        versionStatus?: Array<ResourceVersionStatus>,
    ): CancelablePromise<Array<ResourceVersionOut>> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/resources/{rid}/versions',
            path: {
                'rid': rid,
            },
            query: {
                'version_status': versionStatus,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Request new version of a resource
     * Request a new resource version.
     *
     * Permission `resource:update` required if the current user is the maintainer, `resource:update_any` otherwise.
     * @param rid
     * @param requestBody
     * @returns ResourceVersionOut Successful Response
     * @throws ApiError
     */
    public static resourceVersionRequestResourceVersion(
        rid: string,
        requestBody: ResourceVersionIn,
    ): CancelablePromise<ResourceVersionOut> {
        return __request(OpenAPI, {
            method: 'POST',
            url: '/resources/{rid}/versions',
            path: {
                'rid': rid,
            },
            body: requestBody,
            mediaType: 'application/json',
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Get version of a resource
     * Get a specific resource version for a specific resource.
     *
     * Permission `resource:read` required. If the status of the resource version is not `LATEST` or `SYNCHRONIZED` and
     * the current user is not the maintainer, then the permission `resource:read_any` is required.
     * @param rid
     * @param rvid
     * @returns ResourceVersionOut Successful Response
     * @throws ApiError
     */
    public static resourceVersionGetResourceVersion(
        rid: string,
        rvid: string,
    ): CancelablePromise<ResourceVersionOut> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/resources/{rid}/versions/{rvid}',
            path: {
                'rid': rid,
                'rvid': rvid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Download folder structure of resource
     * Get the folder structure of the resources. Only available if the resource was previously downloaded to the cluster.
     *
     * Permission `resource:read` required.
     * @param rvid
     * @param rid
     * @returns FileTree Successful Response
     * @throws ApiError
     */
    public static resourceVersionResourceFileTree(
        rvid: string,
        rid: string,
    ): CancelablePromise<Array<FileTree>> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/resources/{rid}/versions/{rvid}/tree',
            path: {
                'rvid': rvid,
                'rid': rid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Request resource version review
     * Request the review of a resource version.
     *
     * Permission `resource:update` required.
     * @param rid
     * @param rvid
     * @returns ResourceVersionOut Successful Response
     * @throws ApiError
     */
    public static resourceVersionRequestResourceVersionReview(
        rid: string,
        rvid: string,
    ): CancelablePromise<ResourceVersionOut> {
        return __request(OpenAPI, {
            method: 'PUT',
            url: '/resources/{rid}/versions/{rvid}/request_review',
            path: {
                'rid': rid,
                'rvid': rvid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Request resource version synchronization
     * Request the synchronization of a resource version to the cluster.
     *
     * Permission `resource:request_sync` required.
     * @param rid
     * @param rvid
     * @param requestBody
     * @returns ResourceVersionOut Successful Response
     * @throws ApiError
     */
    public static resourceVersionRequestResourceVersionSync(
        rid: string,
        rvid: string,
        requestBody: UserSynchronizationRequestIn,
    ): CancelablePromise<ResourceVersionOut> {
        return __request(OpenAPI, {
            method: 'PUT',
            url: '/resources/{rid}/versions/{rvid}/request_sync',
            path: {
                'rid': rid,
                'rvid': rvid,
            },
            body: requestBody,
            mediaType: 'application/json',
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Review resource version
     * Review answer the resource version.
     *
     * Permission `resource:update_status` required.
     * @param rid
     * @param rvid
     * @param requestBody
     * @returns ResourceVersionOut Successful Response
     * @throws ApiError
     */
    public static resourceVersionResourceVersionReview(
        rid: string,
        rvid: string,
        requestBody: UserRequestAnswer,
    ): CancelablePromise<ResourceVersionOut> {
        return __request(OpenAPI, {
            method: 'PUT',
            url: '/resources/{rid}/versions/{rvid}/review',
            path: {
                'rid': rid,
                'rvid': rvid,
            },
            body: requestBody,
            mediaType: 'application/json',
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Synchronize resource version with cluster
     * Synchronize the resource version to the cluster.
     *
     * Permission `resource:update_any` required.
     * @param rid
     * @param rvid
     * @param requestBody
     * @returns ResourceVersionOut Successful Response
     * @throws ApiError
     */
    public static resourceVersionResourceVersionSync(
        rid: string,
        rvid: string,
        requestBody: UserRequestAnswer,
    ): CancelablePromise<ResourceVersionOut> {
        return __request(OpenAPI, {
            method: 'PUT',
            url: '/resources/{rid}/versions/{rvid}/sync',
            path: {
                'rid': rid,
                'rvid': rvid,
            },
            body: requestBody,
            mediaType: 'application/json',
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Set resource version to latest
     * Set the resource version as the latest version.
     *
     * Permission `resource:update_any` required.
     * @param rid
     * @param rvid
     * @returns ResourceVersionOut Successful Response
     * @throws ApiError
     */
    public static resourceVersionResourceVersionLatest(
        rid: string,
        rvid: string,
    ): CancelablePromise<ResourceVersionOut> {
        return __request(OpenAPI, {
            method: 'PUT',
            url: '/resources/{rid}/versions/{rvid}/latest',
            path: {
                'rid': rid,
                'rvid': rvid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Delete resource version on cluster
     * Delete the resource version on the cluster.
     *
     * Permission `resource:delete_any` required.
     * @param rid
     * @param rvid
     * @returns ResourceVersionOut Successful Response
     * @throws ApiError
     */
    public static resourceVersionDeleteResourceVersionCluster(
        rid: string,
        rvid: string,
    ): CancelablePromise<ResourceVersionOut> {
        return __request(OpenAPI, {
            method: 'DELETE',
            url: '/resources/{rid}/versions/{rvid}/cluster',
            path: {
                'rid': rid,
                'rvid': rvid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
    /**
     * Delete resource version in S3
     * Delete the resource version in the S3 bucket.
     *
     * Permission `resource:delete_any` required.
     * @param rid
     * @param rvid
     * @returns ResourceVersionOut Successful Response
     * @throws ApiError
     */
    public static resourceVersionDeleteResourceVersionS3(
        rid: string,
        rvid: string,
    ): CancelablePromise<ResourceVersionOut> {
        return __request(OpenAPI, {
            method: 'DELETE',
            url: '/resources/{rid}/versions/{rvid}/s3',
            path: {
                'rid': rid,
                'rvid': rvid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                401: `Not Authenticated`,
                403: `Not Authorized`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }
}
